// HV1Object.h : Declaration of the CHV1Object

#ifndef __HV1OBJECT_H_
#define __HV1OBJECT_H_

#include "resource.h"       // main symbols
#import "D:\users\amato\work\ECHO-trees\SDK-distribution\interfaces\Object.tlb" raw_interfaces_only, raw_native_types, no_namespace, named_guids 
#import "D:\users\amato\work\ECHO-trees\Object\Object.tlb" raw_interfaces_only, raw_native_types, no_namespace, named_guids 

/////////////////////////////////////////////////////////////////////////////
// CHV1Object
class ATL_NO_VTABLE CHV1Object : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CHV1Object, &CLSID_HV1Object>,
	public IDispatchImpl<IHV1Object, &IID_IHV1Object, &LIBID_HV1Lib>,
	public IDispatchImpl<IMTobject, &IID_IMTobject, &LIBID_MTOBJECTLib>
{
public:
	CHV1Object();
	~CHV1Object();

DECLARE_REGISTRY_RESOURCEID(IDR_HV1OBJECT)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CHV1Object)
	COM_INTERFACE_ENTRY(IHV1Object)
//	COM_INTERFACE_ENTRY2(IDispatch, IHV1Object)
	COM_INTERFACE_ENTRY(IMTobject)
END_COM_MAP()

// IHV1Object
public:
	static int ninst;

private:
	double * x;
	static int dimension;
public:
// IMTobject
	STDMETHOD(distance)(IMTobject * o, DOUBLE * d);
	STDMETHOD(compress)(unsigned char * buff, INT * size);
	STDMETHOD(compressedSize)(INT * size);
	STDMETHOD(initialize)(unsigned char * buff);
	STDMETHOD(equal)(IMTobject * obj, INT * res);
	STDMETHOD(XMLInitialize)(CHAR * buff);
};

#endif //__HV1OBJECT_H_
